% Costanti fisiche
global g = 9.81;
% Dati sul carico a monte
global h1 = 2;
global z1 = 1;
% Dati sul fluido
global rho = 1e3;
global mu = 1e-3;
% Dati sulla condotta
global D = 0.05;
global Q = 2e-3;
global L = 50;

function z = target_function(es)
	global g;
	global h1;
	global z1;
	global rho;
	global mu;
	global D;
	global Q;
	global L;

	% Calcolo la velocità
	v = hspeed(Q, D);
	% Calcolo il carico totale
	H12 = h1 + z1 - v.^2/(2.*g);
	% Calcolo la viscosità cinematica
	nu = mu ./ rho;
	% Calcolo il numero di Reynolds
	Re = Reynolds(v, D, nu);
	% Calcolo il coefficiente di attrito
	f = churchill(Re, es ./ D);
	% Calcolo le perdite di carico distribuite
	dloss = loss_l(f, D, L, v, g);
	% Calcolo il valore della funzione
	z = H12 - dloss;
end

% target_function(0.001)

% Traccio la funzione
x = linspace(0, D, 200);
plot(x, target_function(x));
grid()

% Soluzione usando il metodo di Octave
[X, FVAL, INFO] = fsolve(@target_function, 0.001);
X, FVAL, INFO